# -*- coding: ISO-8859-1 -*-

# Copyright (C) 2004 Jrg Lehmann <joerg@luga.de>
#
# This file is part of PyTone (http://www.luga.de/pytone/)
#
# PyTone is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# PyTone is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PyTone; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import threading
import config

class plugin:

    def __init__(self, channel, config, mainscreen):
        """ create a plugin instance """
        self.channel = channel
        self.config = config
        self.mainscreen = mainscreen

    def start(self):
        """ start plugin after it has been configured """
        pass


class threadedplugin(threading.Thread, plugin):

    def __init__(self, channel, config, mainscreen):
        threading.Thread.__init__(self)
        plugin.__init__(self, channel, config.mainscreen)
        
        # as independent thread, we want our own event and request channel
        # and need at least respond to a quit event
        self.channel = hub.newchannel()
        self.channel.subscribe(events.quit, self.quit)
        self.done = False

    def start(self):
        self.run()

    def run(self):
        """main loop"""
        while not self.done:
            self.channel.process(blocking=True)

    # event handlers

    def quit(self, event):
        self.done = True
